      SUBROUTINE CLEV(NL1,NL2,LP,NCMAX,NI4,NBOD,NCN,NBA,XA,
     1 XB,D,LD,NXY,MA,FPD,IP)
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     92/06/22
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     08:47:48
C     PROGRAMMER NAME:                                  J.T.WEST
C     MODULE NAME:                                      MACLEV
C     CURRENT ARCHIVING LEVEL NUMBER:                   00001
C     CURRENT NUMBER OF PERMANENT UPDATES:              00001
C     DATE OF LAST ACCESS BY LIBRARIAN:                 93/03/15
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
C * THIS ROUTINE TRANSLATES PARTICLE COORDINATE FROM HIGHER LEVEL,*
C *  MORE LOCAL COORD SYSTEM TO LOWER,MORE GLOBAL GEOM LEVEL NO.
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*4 D
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
      COMMON/ARK/NGY,NLL,NBB,NZY(3),XD(3)
      COMMON /MGOMV/  MUS,MUZ,LL,IPRET,IFLOW,IECT,NLO,IGX
      COMMON/ARAR/NBY,NLEV,NAR,NQ,IAW,IAY,NF,NX1(3)
CST 2000/06/22
CST   DIMENSION LP(*),XA(3),XC(3),IP(*),NCMAX(*),
      DIMENSION LP(*),XA(3),      IP(*),NCMAX(*),
     1 NI4(*),NBOD(*),NCN(*),NBA(*),NXY(3),D(*),LD(*),MA(*),FPD(*),XB(3)
C
C......SUBROUTINE CLEV TRANSLATES COORDINATES IN XA IN LEVEL NL1
C....TO COORDINAGES XB IN LEVEL NL2, WHERE LEVEL NL2 IS LESS THAN NL1, A
C.....LEVEL NL2 IS A MORE GLOBAL LEVEL (HIGHER IN THE HIEHARCHY) THAN LE
C
C.....COORDINATE XA ARE IN LEVEL NL1
C
      DO 5 I=1,3
   5  XB(I)=XA(I)
      NLM=NL1-NL2+1
      IF(NL1.LT.NL2) GO TO 777
      DO 40 L=1,NLM
      NLT=NL1-L+1
      IF(NLT.GT.0) GO TO 30
      NBB=LP(1)
      NLL=LP(6)
      NGY=NBB
      LL=0
      CALL RTEXIT(XB,MA,FPD,D,LD,IP,NQ,NBA,NBB)
      RETURN
  30  CONTINUE
      IL=6*NLT
      II=6*(NLT-1)
      IF(NLT.EQ.NLEV) GO TO 15
      NBY=LP(IL+1)
      IF(NBY.EQ.0) GO TO 15
      CALL RTEXIT(XB,MA,FPD,D,LD,IP,NQ,NBA,NBY)
  15  CONTINUE
      NGY=LP(II+2)
      DO 10 I=1,3
  10  NXY(I)=LP(II+I+2)
      NLL=LP(IL)
      IF(NGY) 25,777,20
  20  CONTINUE
      LL=NGY
      NBB=NBOD(NGY)
      CALL TRENTE(XB,MA,FPD,D,LD,IP,NQ,NBA,NBB)
  25  CONTINUE
      N=3*(NLL-1)+1
      NR=NCN(N)
      NX=+1
      CALL CTRAN(XB,NCMAX(N),NXY,NX,NCN(N),D(NR),D,LD,IER)
  40  CONTINUE
      RETURN
 777  CONTINUE
      WRITE(IOT,600) NL1,NL2,NGY
 600  FORMAT(5X,'ERROR IN CLEV * NL1=',I5,' NL2=',I5,' NGY=',I5)
      CALL DIPR(D,IP,2)
      CALL ABEND(LD)
      RETURN
      END
