      SUBROUTINE G1(S,MA,FPD,LOCREG,NUMBOD,IROR,IR1,IR2,NSTO)
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     98/04/14
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     10:11:33
C     PROGRAMMER NAME:                                  J.T.WEST
C     MODULE NAME:                                      MAG1
C     CURRENT ARCHIVING LEVEL NUMBER:                   00006
C     CURRENT NUMBER OF PERMANENT UPDATES:              00006
C     DATE OF LAST ACCESS BY LIBRARIAN:                 98/04/14
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
C * *  THIS IS THE CONTROL ROUTINE FOR COMBINATORIAL GEOMETRY.
C     IN TO G1, IRPRIM=CODE ZONE
C                IR=INPUT ZONE
C     OUT OF G1, IR=CODE ZONE
C                IRPRIM=INPUT ZONE
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION MA(*),FPD(*),LOCREG(*),NUMBOD(*),IROR(*),NSTO(*)
      COMMON/GOMLOC/ KMA,KFPD,KLCR,KNBD,KIOR,KRIZ,KRCZ,KMIZ,KMCZ,KKR1,
     1 KKR2,KNSR,KVOL,NADD,LDATA,LTMA,LFPD,NUMR,IRTRU,NUMB,NIR,KBIZ,KBCZ
      REAL*8 XB,WB,WP,XP,RIN,ROUT,PINF,DIST
      COMMON/PAREM/XB(3),WB(3),WP(3),XP(3),RIN,ROUT,PINF,DIST,IR,IDBG ,
     1             IRPRIM,NASC,LSURF,NBO,LRI,LRO,KLOOP,LOOP,ITYPE,NOA
      COMMON /DBG/ N,NUM,LOCAT,ISAVE,INEXT,IRP,SMIN,INEX
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
      COMMON /MGOMV/  MUS,MUZ,LL,IPRET,IFLOW,IECT,NLO,IGX
      REAL*8 DIST0
      INTEGER BLZOLD
      COMMON /ORGI/ DIST0,MARKG,NMEDG,NBLZ,BLZOLD,IRPOLD
C     EQUIVALENCE (SRIN,RIN),(SROU,ROUT),(SDIS,DIST)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      COMMON/FLAG/IERROR
CTAT
      DATA EPS/ 1.0D-6/
      DATA IST/0/
      LMAX=LTMA
      SP=0.
      IRP=IRPRIM
      IF(LL.NE.NSTO(KBCZ+IRP-1)) GO TO 100
      IF(NASC.GT.0) GO TO 110
      KLOOP=KLOOP+1
      DIST=0.
  110 SMIN=PINF
      ISAVE=0
  130 CONTINUE
      IRR=IRP
      N=LOCREG(IRR) +1
      NUM=NUMBOD(IRR)*5+N-5
      IF(IDBG.NE.0) CALL PR(NSTO,1)
C THE LOOP UPTO 300 FINDS THE NEXT BODY THAT THE RAY WILL INTERSECT
C
      DO  300  I=N,NUM,5
      NBO=MA(I)
      LOCAT=MA(I+1)
      CALL GG(LOCAT,MA,FPD,NSTO)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      IF(IDBG.NE.0) CALL PR(NSTO,2)
      IF(ROUT.LE.0) GO TO 300
      IF(NBO) 147,300,197
  147 IF(ROUT.LE.DIST)  GO TO 300
      IF(RIN.GT.DIST)   GO TO 1477
      GO TO 300
 1477 RMS=RIN-SMIN
      IF(RMS) 149,151,148
  148 IF(RMS-SMIN*EPS) 150,150,300
  149 IF(-RMS.GE.SMIN*EPS) GO TO 150
      K=MA(LOCAT+6)
      FPD(K)=SMIN
      GO TO 151
  150 SMIN=RIN
  151 NASC=-NBO
      LSURF=LRI
      ISAVE=I
      GO TO  300
  197 IF(ROUT.GT.DIST)  GO TO 1999
      GO TO 300
 1999 RMS=ROUT -SMIN
      IF(RMS) 199,200,198
  198 IF(RMS-SMIN*EPS) 200,200,300
  199 IF(-RMS.GE.SMIN*EPS) GO TO 200
      K=MA(LOCAT+6)
      FPD(K+1)=SMIN
      GO TO 201
  200 SMIN=ROUT
  201 NASC=NBO
      LSURF=-LRO
      ISAVE=I
  300 CONTINUE
  302 CONTINUE
      IF(ISAVE.NE.0) GO TO 309
      IRPRIM=-3
CTAT/ADD FOR BUGFIX---FROM
      IERROR=-1
CTAT/ADD FOR BUGFIX---TO
      IECT=IECT+1
      IF(IECT.GT.10) RETURN
      WRITE(IOT ,305) IR,XB,WB,DIST
  305 FORMAT(' ****  WARNING FROM SUBROUTINE G1'/
     :  ' AT REGION ',I5,' (X,Y,Z)=(',G10.3,',',G10.3,',',G10.3,')',
     :  ' DIRECTION =(',G10.3,',',G10.3,',',G10.3,')'/
     :  '  PARTICLE TRANSPORT DISTANSE=',G10.3)
C 305 FORMAT(' NO VALID DISTANCE IN G1 * IR,XB,WB,DIST=',
C    1 /(I5,7D15.8))
      RETURN
C
C NOW TO FIND NEXT REGION
C
  309 S=SMIN -DIST+SP
      DIST=SMIN
      INEXT=ISAVE+2
      IF(DIST.LT.DIST0)  GO TO 312
      S=S-DIST+DIST0
      DIST=DIST0
      IRPRIM=IR
      IR=IRP
      MARKG=1
      RETURN
  312 MARKG=0
  310 IRP=MA(INEXT)
      IF(IDBG.NE.0) CALL PR(NSTO,3)
      IF( IRP.EQ.0)GO TO  600
      IF(LL.NE.NSTO(KBCZ+IRP-1)) GO TO 100
      N=LOCREG(IRP)+1
      NUM=NUMBOD(IRP)*5 + N-5
C
C THE LOOP TO 400 EXAMINES REGION IRP TO SEE IF IT IS THE NEXT REGION
C
      IF(IDBG.NE.0) CALL PR(NSTO,4)
      DO 400 I=N,NUM,5
      NBO=MA(I)
      LOCAT=MA(I+1)
      CALL GG(LOCAT,MA,FPD,NSTO)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      DLTA = EPS*DIST
      IF(IDBG.NE.0) CALL PR(NSTO,5)
      IF(NBO) 320,400 ,330
  320 IF( (ROUT-DIST).LE.DLTA.OR.(RIN-DIST).GT.DLTA) GO TO 400
      GO TO 500
  330 IF( (RIN-DIST).LE.DLTA.AND.(DIST.LT.ROUT)) GO TO 400
      GO TO 500
  400 CONTINUE
C
C FOUND A REGION
      MA(INEXT+1) = MA(INEXT+1)+1
      GO TO 750
  500 INEX=INEXT + 2
C *** THE +2 ABOVE IS DUE TO NEW JTW COMPONENT IN MA ARRAY ****
      INEXT= MA(INEX)
      IF(INEXT .GT.0) GO TO 310
      INEXT=LDATA
  600 CONTINUE
      IF(IDBG.NE.0) CALL PR(NSTO,6)
C%%<03/19/97 SUMITOMO: TREATMENT OF NEAREST CROSSING POINT
      KKLOOP=0
  601 CONTINUE
C%%>
      DO  700 IRR=1,NUMR
      IRP=IRR
      IF(LL.NE.NSTO(KBCZ+IRP-1)) GO TO 700
C%%<03/19/97 SUMITOMO
      IF(KKLOOP.EQ.1) GOTO 615
C%%>
C
C  BEFORE LOOPING THRU  ZONE  IRP SEE IF IT HAS BEEN CKED BEFORE
C    IN TABLE LOOKUP LOOP PRECEDING THIS LOOP
      I2 = ISAVE+2
      IF(MA(I2).EQ.0) GO TO 615
  610 CONTINUE
      IF(IRP.EQ.MA(I2)) GO TO 700
      I2 = MA(I2+2)
      IF(I2.GT.0) GO TO 610
 615  CONTINUE
      N=LOCREG(IRP)+1
      NUM=NUMBOD(IRP)*5+N-5
      DO  650   I=N,NUM,5
      NBO=MA(I)
      LOCAT=MA(I+1)
      CALL GG(LOCAT,MA,FPD,NSTO)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      DLTA = EPS*DIST
      IF(IDBG.NE.0) CALL PR(NSTO,7)
      IF(NBO) 620,650,630
  620 IF( (ROUT-DIST).LE.DLTA. OR.(RIN-DIST).GT.DLTA) GO TO 650
C%%<03/19/97 SUMITOMO: TREATMENT OF NEAREST CROSSING POINT
      IF(KKLOOP.EQ.1) THEN
       IF((ROUT-DIST).LE.DLTA*2..OR.(RIN-DIST).GT.DLTA*0.5) GO TO 650
      ENDIF
C%%>
      GO TO 700
C%% SUMITOMO
  630 IF( (RIN-DIST).LE.DLTA.AND.(DIST.LT.ROUT)) GO TO 650
C%%<03/19/97 SUMITOMO: TREATMENT OF NEAREST CROSSING POINT
      IF(KKLOOP.EQ.1) THEN
         IF((RIN-DIST).LE.DLTA*2..AND.(DIST.LT.ROUT)) GO TO 650
      ENDIF
C%%>
      GO TO 700
  650 CONTINUE
      IF(INEXT.NE.LDATA) GO TO 652
      IF(INEXT.GE.LMAX-3) GO TO 651
C *** THE 3  ABOVE IS DUE TO JTW ADDED DATA  ****
      MA(INEX)=INEXT
      LDATA=LDATA+3
C *** THE 3  ABOVE IS DUE TO JTW ADDED DATA  ****
  652 MA(INEXT)=IRP
      MA(INEXT+1) = 1
      GO TO 750
  651 IF(IST.NE.0)GO TO 750
      IST=1
C%%<
C%%      WRITE(IOT ,655)
C%655 FORMAT(40X,'****************************************'/
C%%  1 47X,'GEOMETRY SEARCH ARRAY FULL '/
C%%  2       40X,'****************************************')
      WRITE(IOT,655) LMAX-3
  655 FORMAT(40X,'***********************************************'
     &      /40X,'  GEOMETRY SEARCH ARRAY FULL (LIMIT=',I8,')'
     &      /40X,'***********************************************')
C%%>
      GO TO 750
  700 CONTINUE
      IRPRIM=0
CADDED BY ST 98/10/28 FOR UNDEFINED REGION SEARCHING
      IERROR=3
      IECT=IECT+1
      IF(IECT.GT.10) RETURN
C%%<
C%%   WRITE(IOT ,1000) IR,XB,WB,DIST
C%% 1000 FORMAT(' *** WARNING IN GG *** REGION(',I3,') AT POINT(',
C%%  : 3(1PE10.3,','),')'/
C%%  : '  NEXT POINT WILL BE OUT OF GEOMETRY OR UNDEFINED REGION'/
C%%  : '  PARTICLE DIRECTION =(',3(E10.3,','),')  '/
C%%  : '  PARTICLE WILL TRANSPORT THROUGH DISTANCE:',E12.4)
      KKLOOP=KKLOOP+1
      IF(KKLOOP.EQ.1) THEN
         WRITE(IOT,1000) IR,XB,WB,DIST,XB(1)+WB(1)*DIST,
     &                   XB(2)+WB(2)*DIST,XB(3)+WB(3)*DIST
         GO TO 601
      ENDIF
      WRITE(IOT,1001)
 1000 FORMAT(' --- MESSAGE IN S.G1 ---'
     &/' IN SEARCHING REGION (',I3,') OF POINT (',1P3E14.6,'),'
     &/' NEXT POINT WILL BE OUT OF GEOMETRY OR UNDEFINED REGION.'
     &/' PARTICLE DIRECTION (',3E14.6,'),  TRANSPORT DISTANCE =',E17.10
     &/' THIS TROUBLE POSITION (',3E16.8,')')
 1001 FORMAT(/' *** ERROR IN S.G1 ***'
     &/' THE REASON IS ABOVE MESSAGE.')
      DO 710 IRR=1,NUMR
      IF(LL.NE.NSTO(KBCZ+IRR-1)) GO TO 710
      N=LOCREG(IRR)+1
      NUM=NUMBOD(IRR)*5+N-5
      WRITE(IOT,1002) IRR,N,NUM
 1002 FORMAT(' REG=',I5,'   N,NUM=',2I7)
      DO 711 I=N,NUM,5
      NBO=MA(I)
      LOCAT=MA(I+1)
      CALL GG(LOCAT,MA,FPD,NSTO)
      DLTA = EPS*DIST
      WRITE(IOT,1003) I,NBO,RIN,ROUT,DIST,DLTA
 1003 FORMAT('   I=',I5,'  NBO=',I4,'  RIN,ROUT=',1P2E15.8,'  DIST=',
     &       2E14.7)
      IF(NBO) 712,711,713
  712 IF((ROUT-DIST).LE.DLTA.OR.(RIN-DIST).GT.DLTA) GO TO 711
      GO TO 710
  713 IF((RIN-DIST).LE.DLTA.AND.(DIST.LT.ROUT)) GO TO 711
      GO TO 710
  711 CONTINUE
  710 CONTINUE
C%%>
C1000 FORMAT(1X,  'IR=',I4,1X,  'XB=',3D15.8,1X,  'WB=',3D15.8,1X,   'DI
C    CST=',     D15.8)
C     CALL PR(NSTO,10)
C     WRITE(IOT ,322)
C 322 FORMAT(//,50X,   'MA  ARRAY',//)
C     DO 321 I=1,LDATA,7
C     K=I+6
C 321 WRITE(IOT ,1001) I,(MA(J), J=I,K), K
C1001 FORMAT(I6,I10,6I6,I10)
C     III=7*NUMB
C     III=MA(III)+24
C     WRITE(IOT ,323)
C 323 FORMAT(//,50X,'FPD ARRAY',//)
C     DO 324 I=1,III,5
C     K=I+4
C 324 WRITE(IOT ,1002) I,(FPD(J), J=I,K), K
C1002 FORMAT(I5,5D20.7,I5)
C     WRITE(IOT ,6666)
C6666 FORMAT('0EXIT BEING CALLED FROM G1, NEXT ZONE NOT FOUND.' )
      CALL ABEND(NSTO)
CHANGED BY ST 96/12/18
C     STOP
      RETURN
  750 IRPRIM=IROR(IRP)
      IF(IDBG.NE.0) CALL PR(NSTO,8)
      IF(IRPRIM.NE.IR)GO TO 800
      SP=S
      BLZOLD= IRPRIM+32768*IRP
      IRPRIM=IRP
      GO TO 110
  800 IR=IRP
      RETURN
 100  WRITE(IOT ,105)  IRP,LL
 105  FORMAT('1',///,5X,'CODE ZONE',I5,' IS NOT IN UNIVERSE ',I5,//)
      CALL PR(NSTO,1)
      CALL ABEND(NSTO)
      RETURN
      END
