      SUBROUTINE LOOKZ(X,Y,Z,NSTO ,MA,FPD,LOCREG,NUMBOD,IROR,NSOR)
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     92/06/22
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     08:55:32
C     PROGRAMMER NAME:                                  J.T.WEST
C     MODULE NAME:                                      MALOOKZ
C     CURRENT ARCHIVING LEVEL NUMBER:                   00004
C     CURRENT NUMBER OF PERMANENT UPDATES:              00004
C     DATE OF LAST ACCESS BY LIBRARIAN:                 93/03/15
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
C      THIS ROUTINE RETURNS THE COMBINATORIAL GEOMETRY ZONE OF POINT  *
C          (X,Y,Z)  SO TRACKING CAN BE INITIALIZED.
C
      IMPLICIT REAL*8 (A-H,O-Z)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      COMMON/FLAG/IERROR
CTAT
      DIMENSION MA(*),FPD(*),LOCREG(*),NUMBOD(*),IROR(*),NSOR(*),NSTO(*)
      COMMON/GOMLOC/ KMA,KFPD,KLCR,KNBD,KIOR,KRIZ,KRCZ,KMIZ,KMCZ,KKR1,
     1 KKR2,KNSR,KVOL,NADD,LDATA,LTMA,LFPD,NUMR,IRTRU,NUMB,NIR,KBIZ,KBCZ
      REAL*8 DIST0
      INTEGER BLZOLD
      COMMON /ORGI/ DIST0,MARKG,NMEDG,NBLZ,BLZOLD,IRPOLD
      REAL*8 XB,WB,WP,XP,RIN,ROUT,PINF,DIST
      COMMON/PAREM/XB(3),WB(3),WP(3),XP(3),RIN,ROUT,PINF,DIST,IR,IDBG ,
     1             IRPRIM,NASC,LSURF,NBO,LRI,LRO,KLOOP,LOOP,ITYPE,NOA
      COMMON /DBG/ N,NUM,LOCAT,ISAVE,INEXT,IRP,SMIN,INEX
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
      COMMON /MGOMV/  MUS,MUZ,LL,IPRET,IFLOW,IECT,NLO,IGX
      DATA EPS /1.0D-5/
      IF(LL.EQ.0) GO TO 10
      IF(LL.NE.LLOLD) GO TO 20
 10   CONTINUE
      IF(X.EQ.XB(1).AND.Y.EQ.XB(2).AND.Z.EQ.XB(3))   RETURN
  20  LLOLD=LL
      KLOOP=KLOOP+1
      XB(1)=X
      XB(2)=Y
      XB(3)=Z
C     WB(1)=0.8D0
C     WB(2)=0.6D0
C     WB(3)=0.0D0
CHANGED BY ST 96/12/18
C     DIST=1.0D-8
      DIST=0.0D0
      DO 500 IS=1,NUMR
      IRP=NSOR(IS)
      IF( IRP.EQ.0)GO TO  600
      IF(LL.NE.NSTO(KBCZ+IRP-1)) GO TO 500
      N=LOCREG(IRP)+1
      NUM=NUMBOD(IRP)*5 + N-5
C
C THE LOOP TO 400 EXAMINES REGION IRP TO SEE IF IT IS THE NEXT REGION
C
      IF(IDBG.NE.0) CALL PR(NSTO,4)
      DO 400 I=N,NUM,5
      NBO=MA(I)
      LOCAT=MA(I+1)
      CALL GG(LOCAT,MA,FPD,NSTO)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      DLTA = EPS*DIST
      IF(IDBG.NE.0) CALL PR(NSTO,5)
      IF(NBO) 320,400 ,330
  320 IF((ROUT-DIST).LE.DLTA.OR.(RIN-DIST).GT.DLTA) GO TO 400
      GO TO 500
  330 IF( (RIN-DIST).LE.DLTA.AND.(DIST.LT.ROUT) )  GO TO 400
      GO TO 500
  400 CONTINUE
C
C FOUND A REGION
      GO TO 750
  500 CONTINUE
  600 CONTINUE
      INEXT=IS
      IF(IDBG.NE.0) CALL PR(NSTO,6)
      DO  700 IRP=1,NUMR
      IF(LL.NE.NSTO(KBCZ+IRP-1)) GO TO 700
      N=LOCREG(IRP)+1
      NUM=NUMBOD(IRP)*5+N-5
      DO  650   I=N,NUM,5
      NBO=MA(I)
      LOCAT=MA(I+1)
      CALL GG(LOCAT,MA,FPD,NSTO)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      DLTA = EPS*DIST
      IF(IDBG.NE.0) CALL PR(NSTO,7)
      IF(NBO) 620,650,630
  620 IF((ROUT-DIST).LE.DLTA.OR.(RIN-DIST).GT.DLTA) GO TO 650
      GO TO 700
  630 IF((RIN-DIST).LE.DLTA.AND.(DIST.LT.ROUT)) GO TO 650
      GO TO 700
  650 CONTINUE
      NSOR(INEXT)=IRP
      GO TO 750
  700 CONTINUE
      IECT=IECT+1
CADDED BY ST 98/10/28 FOR UNDEFINED REGION SEARCHING
      IERROR=2
      IF(IECT.GT.10) RETURN
      WRITE(IOT ,1000) IR,XB,WB,DIST
 1000 FORMAT(' *** WARNING IN LOOKZ *** REGION(',I3,')  AT POINT(',
     : 3(1PE10.3,','),')'/
     : ' NEXT REGION WILL BE OUT OF GEOMETRY OR UNDEFINED '/
     : '  PARTICLE DIRECTION =(',3(E10.3,','),')  '/
     : '  PARTICLE WILL TRANSPORT THROUGH DISTANCE:',E12.4)
C%% SUMITOMO
C      WRITE(IOT ,1000) IR,XB,WB,DIST,LL
C 1000 FORMAT(1X,  3HIR=,I4,1X,  3HXB=,1P3D14.6,1X,  3HWB=,1P3D14.6,1X,
C     C 5HDIST=,1PD14.6,1X, 3HLL=,I4)
C      WRITE(IOT ,322)
C  322 FORMAT(//,50X,   9HMA  ARRAY,//)
C      DO 321 I=1,LDATA,7
C      K=I+6
C  321 WRITE(IOT ,1001) I,(MA(J), J=I,K), K
C 1001 FORMAT(I5,I10,6I5,I10)
C      III=7*NUMB
C      III=MA(III)+24
C      WRITE(IOT ,323)
C  323 FORMAT(//,50X,9HFPD ARRAY,//)
C      DO 324 I=1,III,5
C      K=I+4
C  324 WRITE(IOT ,1002) I,(FPD(J), J=I,K), K
C 1002 FORMAT(I5,5D20.7,I5)
C      WRITE(IOT ,1003)
C1003  FORMAT(1H0,32H****EXIT BEING CALLED FROM LOOKZ   )
      IRPRIM=0
      CALL ABEND(NSTO)
CHANGED BY ST 96/12/18
C     STOP
      RETURN
  750 IRPRIM=IROR(IRP)
      IR=IRP
C     IRPRIM IS THE COMBINATORIAL INPUT ZONE NUMBER - IR IS CODE ZONE
C    THIS IS CONSISTENT WITH DEFINITION IN G1
      IF(IDBG.NE.0) CALL PR(NSTO,8)
      NMEDG=IRPRIM
      NBLZ =32768*IRP+IRPRIM
      RETURN
      END
