      SUBROUTINE PILOT(NL,NLU,XA,IP,NCMAX,NI4,
     1 NBOD,NCN,NBA,FPD,MA,LOCREG,D,LD)
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     95/08/30
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     13:51:09
C     PROGRAMMER NAME:                                  J.T.WEST
C     MODULE NAME:                                      MAPILOT
C     CURRENT ARCHIVING LEVEL NUMBER:                   00003
C     CURRENT NUMBER OF PERMANENT UPDATES:              00003
C     DATE OF LAST ACCESS BY LIBRARIAN:                 95/08/30
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
C     THIS ROUTINE DETERMINES NEXT INPUT ZONE PARTICLE ENTERS ***
C     ON ENTERING OR LEAVING PILOT, IR=CODE ZONE
C                                  IRPRIM=INPUT ZONE
C     INSIDE  PILOT WHEN CALLING G1, IRPRIM=CODE ZONE
C                                   IR=INPUT ZONE
C ****** THIS MAKES PILOT CONSISTENT WITH G1 ******
      IMPLICIT REAL*8 (A-H,O-Z)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      COMMON/FLAG/IERROR
CTAT
      REAL*4 D
      COMMON/ARK/NGY,NLL,NBB,NZY(3),XD(3)
      COMMON/ARAR/NBY,NLEV,NAR,NQ,IAW,IAY,NF,NX1(3)
      COMMON/GOMLOC/ KMA,KFPD,KLCR,KNBD,KIOR,KRIZ,KRCZ,KMIZ,KMCZ,KKR1,
     1 KKR2,KNSR,KVOL,NADD,LDATA,LTMA,LFPD,NUMR,IRTRU,NUMB,NIR,KBIZ,KBCZ
      REAL*8 XB,WB,WP,XP,RIN,ROUT,PINF,DIST
      COMMON/PAREM/XB(3),WB(3),WP(3),XP(3),RIN,ROUT,PINF,DIST,IR,IDBG ,
     1             IRPRIM,NASC,LSURF,NBO,LRI,LRO,KLOOP,LOOP,ITYPE,NOA
      REAL*8 DIST0
      INTEGER BLZOLD
      COMMON /ORGI/ DIST0,MARKG,NMEDG,NBLZ,BLZOLD,IRPOLD
      COMMON /MGOMV/  MUS,MUZ,LL,IPRET,IFLOW,IECT,NLO,IGX
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
      COMMON/SS/S1
      DIMENSION MA(*),FPD(*),XA(3),IP(*),NCMAX(*),
     1 NI4(*),NBOD(*),NCN(*),NBA(*),D(*),LD(*),LOCREG(*),NX2(3)
      SAVE LM
      IDB=IDBG
      ICT=0
      NMOLD=LD(KMIZ+IRPRIM-1)
      NROLD=LD(KRIZ+IRPRIM-1)
      IPS=0
      IEXIT=0
      S1=0.0
      IN=IP(NQ+11)
  15  CONTINUE
      DO 10 I=1,3
      XB(I)=XA(I)
  10  CONTINUE
  12  CONTINUE
CST
      IF(IRPRIM.EQ.0.AND.IR.EQ.0) THEN
       CALL ERRTRA
       RETURN
      ENDIF
CST
      MARKG=0
      ITEMP = IR
      IR = IRPRIM
      IRPRIM = ITEMP
      CALL G1(  S,MA,FPD,D(KLCR),D(KNBD),D(KIOR),IR1,IR2,D )
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      IF(IRPRIM.LE.0) RETURN
      S1=S1+S
 700  CONTINUE
      ICT=ICT+1
      IF(ICT.LE.500) GO TO 701
      WRITE(IOT,640)
 640  FORMAT('0PROBLEM ENCOUNTERED IN ARRAY PROCESSING, PARTICLE WILL '
     1 ,'BE TERMINATED AS ESCAPE.' )
      IRPRIM=-3
      RETURN
 701  CONTINUE
      NMED=LD(KMCZ+IR-1)
      IF(IDB.EQ.0) GO TO 750
      WRITE(IOT,711) NL,NLU,IR,IRPRIM,NMED,MARKG,NLEV,DIST0,NMOLD
      WRITE(IOT,777) NASC,NBO,LSURF,LRI,LRO,KLOOP,LOOP,ITYPE,S,DIST,
     1 RIN,ROUT
 777  FORMAT(/,5X,8I5,/,5X,1P4E15.5,/)
      CALL DIPR(D,IP,-1)
 711  FORMAT(5X,'PILOT CRASH',7I5,1PE15.5,I5)
 750  CONTINUE
C  *** IF NMED<0, GO TO ARRAY PROCESSING ROUTINES
      IF(NMED.LT.0) GO TO 14
C  **  IF COMPLETED PATH; I.E.,  REAL COLLISION - RETURN
      IF(MARKG.EQ.1) RETURN
      NREG=LD(KRCZ+IR-1)
C  *** IF MARKG=0 AND NMED OR NREG HAS CHANGED,IT'S BDRYX - RETURN
      IF(NMED.NE.NMOLD) RETURN
      IF(NREG.NE.NROLD) RETURN
      IF(IPRET.GT.0) RETURN
C ***  MARKG=0,NO CHANGE IN NMED OR NREG - CONTINUE IN PILOT
      BLZOLD=IRPRIM+32768*IR
      IRPOLD=IRPRIM
      GO TO 12
C *** ARRAY GEOM CALCULATIONS FOLLOW  **********
  14  CONTINUE
      KLOOP=KLOOP+1
      DO 17 I=1,3
      XA(I)=XA(I)+DIST*WB(I)
  17  CONTINUE
      DIST0=DIST0-DIST
      DIST=0.0
      IF(NMED.EQ.-1000) GO TO 500
C ******* PARTICLE ENTERING ARRAY ************;
      NLU=IABS(NMED)
      IA=LOCREG(IR)
      NBY=MA(IA+1)
      NBU=NBY
      CALL TRENTE(XA,MA,FPD,D,LD,IP,NQ,NBA,NBY)
  20  NL=NL+1
      NLO=+1
      M=NI4(NLU)
      IGX=0
      CALL CELL(XA,MA,FPD,NLU,NCMAX,NI4,D(M),NBOD,NCN,D,LD,NX1,
     1 LU,LM,IER,LZ)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      CALL STORA(D,LD,LM,LD(IN),NL,NLU,NX1,IP,NBU)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      NLL=NLU
      NBB=NBY
      DO 22 MM=1,3
      NZY(MM)=NX1(MM)
      XD(MM)=XA(MM)
  22  CONTINUE
      L1=-1
      IF(IDB.EQ.1) CALL DIPR(D,IP,L1)
      IF(IER.NE.0) GO TO 40
C **** LZ GT 0  FATAL ON ENTERING ARRAY ******
      IF(LZ.GT.0.OR.LM.EQ.0) GO TO 40
 300  CONTINUE
      N=3*(NLU-1)+1
      NR=NCN(N)
      NX=-1
      CALL CTRAN(XA,NCMAX(N),NX1,NX,NCN(N),D(NR),D,LD,IER)
      IF(LM) 25,40,30
  25  CONTINUE
      NLU=IABS(LM)
      GO TO 20
  30  CONTINUE
      NLO=0
      LL=LM
      NBY=NBOD(LM)
CST 2000/06/22
      NBY=NBDNO(NBY,MA)
CST 2000/06/22
      CALL RTEXIT(XA,MA,FPD,D,LD,IP,NQ,NBA,NBY)
      GO TO 580
 500  CONTINUE
C ***** PARTICLE EXITING AN ARRAY **********
C *****       NMED=-1000          **********
      DO 510 I=1,3
 510  NX2(I)=NX1(I)
      NBY=NBOD(LL)
      N=3*(NLU-1)+1
      M=NI4(NLU)
      NR=NCN(N)
CST 2000/06/22
      NBY=NBDNO(NBY,MA)
CST 2000/06/22
      CALL TRENTE(XA,MA,FPD,D,LD,IP,NQ,NBA,NBY)
      NX=1
      CALL CTRAN(XA,NCMAX(N),NX2,NX,NCN(N),D(NR),D,LD,IER)
 515  CONTINUE
      IGX=1
      CALL CELL(XA,MA,FPD,NLU,NCMAX,NI4,D(M),NBOD,NCN,D,LD,NX1,
     1 LU,LM,IER,LZ)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      IF(IER.NE.0) GO TO 50
      IF(LZ.GT.0) GO TO 550
      IF(LM.EQ.0) GO TO 550
      IEXIT=0
 520  CONTINUE
      NX=-1
      CALL CTRAN(XA,NCMAX(N),NX1,NX,NCN(N),D(NR),D,LD,IER)
      NLO=0
      IF(LM.GT.0) GO TO 530
      CALL STORA(D,LD,LM,LD(IN),NL,NLU,NX1,IP,NBU)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      NLU=IABS(LM)
      GO TO 20
 530  CONTINUE
      NBY=NBOD(LM)
      LL=LM
CST 2000/06/22
      NBY=NBDNO(NBY,MA)
CST 2000/06/22
      CALL RTEXIT(XA,MA,FPD,D,LD,IP,NQ,NBA,NBY)
      GO TO 580
 550  NL1=NL
      IF(IEXIT.EQ.1) GO TO 50
      IF(LM.EQ.0) IEXIT=1
      NL=NL-1
      NLO=-1
      CALL CLEV(NL,NL,LD(IN),NCMAX,NI4,NBOD,NCN,NBA,XA,XA,
     1 D,LD,NX1,D(KMA),D(KFPD),IP)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      NASC=LD(IN+6*NL)
      NLU=NLL
      LM=NGY
      N=3*(NLU-1)+1
      NR=NCN(N)
      M=NI4(NLU)
      CALL STORA(D,LD,LM,LD(IN),NL,NLU,NX1,IP,NBU)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      IF(NL) 50,590,560
 560  CONTINUE
      IF(LM) 515,50,520
 580  CONTINUE
      CALL STORA(D,LD,LM,LD(IN),NL,NLU,NX1,IP,NBU)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      NLL=NLU
      NBB=NBY
      DO 24 MM=1,3
      NZY(MM)=NX1(MM)
      XD(MM)=XA(MM)
  24  CONTINUE
 590  CONTINUE
      L1=-1
      IF(IDB.EQ.1) CALL DIPR(D,IP,L1)
      MARKG=0
      IF(LD(MUS+LL-1).EQ.1.AND.LL.GE.1) GO TO 200
      DO 595 I=1,3
 595  XB(I)=0.0
      IF(LZ.EQ.0) GO TO 597
      XA(LZ) =XA(LZ)+ DSIGN(1.0D0,WB(LZ))*1.0D-9
C ***** ABOVE STMT MOVES PARTICLE OFF BNDRY IN CORRECT DIRECTION ****
597   CALL LOOKZ(XA(1),XA(2),XA(3),D,MA,FPD,D(KLCR),D(KNBD),
     1 D(KIOR),D(KNSR))
      GO TO 210
 200  CONTINUE
      DO 610 I=1,3
 610  XB(I) = XA(I)
      KLOOP=KLOOP+1
      IR=LD(MUZ+LL-1)
      IRPRIM=LD(KIOR+IR-1)
      IFLOW=0
 210  CONTINUE
      IF(IRPRIM.LE.0) RETURN
      GO TO 700
  40  CONTINUE
      WRITE(IOT,600) LZ,IER,LM,IEXIT,NL,NMED,IR,IRPRIM
 600  FORMAT(5X,'ERROR IN PILOT ON ENTERING ARRAY',10I5)
      GO TO 55
  50  CONTINUE
      WRITE(IOT,620) LZ,IER,LM,IEXIT,NL,NMED,IR,IRPRIM
 620  FORMAT(5X,'ERROR IN PILOT ON EXITING ARRAY',10I5)
  55  IDBG=0
      CALL PR(D,1)
      CALL ABEND(LD)
      RETURN
      END
