      SUBROUTINE UNIS(NP,IP,D,LD,MA,FPD,LOCREG,NUMR,MCZ,KBZ,IBOD,NUMBOD)
C * * THIS ROUTINE READS, VERIFIES, AND EDITS UNIVERSE TYPE INPUT * *
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     98/07/09
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     15:30:36
C     PROGRAMMER NAME:                                  J.T.WEST
C     MODULE NAME:                                      MAUNIS
C     CURRENT ARCHIVING LEVEL NUMBER:                   00002
C     CURRENT NUMBER OF PERMANENT UPDATES:              00002
C     DATE OF LAST ACCESS BY LIBRARIAN:                 98/07/09
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /MGOMV/  MUS,MUZ,LL,IPRET,IFLOW,IECT,NLO,IGX
      COMMON/JOMK/NBI,IRI,JMK,IML,IOP,IMAX
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
CST
      REAL*4 D
CST
      DIMENSION IP(*),D(*),LD(*),MA(*),FPD(*),LOCREG(*),MCZ(*),KBZ(*),
     1 NUMBOD(*)
      IRET=0
      IFLOW=0
      MUS=IP(NP+14)
      MUZ=MUS+IBOD
      IP(NP+14)=MUZ+IBOD
      ICR=1
      IER=0
      WRITE(IOT,3)
   3  FORMAT(1H1,//,20X,'UNIVERSE SPECIFICATIONS',//,15X,'UNIVERSE',
     1 10X,'1-SIMPLE/0-COMJOM',//)
      DO 200 I=1,IBOD
      II=MUS+I-1
      LD(II)=1
      IF(JMK.EQ.1) GO TO 5
      LD(II)=IREAD(ICR,IRET)
   5  CONTINUE
      ICR=0
      LD(MUZ+I-1)=0
      IF(LD(II).NE.1) GO TO 100
      DO 95 J=1,NUMR
      IF(KBZ(J).NE.I) GO TO 95
      IF(MCZ(J).GE.0) GO TO 20
      IF(MCZ(J).EQ.-1000) GO TO 20
      LD(II)=0
      IAB=IABS(MCZ(J))
      WRITE(IOT,25) I,J,IAB
  25  FORMAT(//,5X,'WARNING -- UNIVERSE',I5,' IS NOT SIMPLE',/,
     1 5X,'CODE ZONE',I5,' CONTAINS ARRAY',I5,//)
  22  FORMAT(/,15X,I5,17X,I5)
      GO TO 100
  20  CONTINUE
      IF(NUMBOD(J).LE.2) GO TO 15
      WRITE(IOT,10) J,I
  10  FORMAT(/,10X,'CODE ZONE',I4,' IN UNIVERSE',I4,' CANNOT BE',
     1 ' A SIMPLE UNIVERSE',//)
      LD(II)=0
      GO TO 100
  15  CONTINUE
      IF(MCZ(J).NE.-1000) GO TO 95
      N=LOCREG(J)+1
      NUM=NUMBOD(J)*5+N-5
      DO 50 NI=N,NUM
      NBO=MA(NI)
      IF(NBO.GE.0) GO TO 50
      NBP=-NBO
      DO 45 M=1,NUMR
      IF(KBZ(M).NE.I) GO TO 45
      IF(M.EQ.J) GO TO 45
      IM=LOCREG(M)+1
      MUM=NUMBOD(M)*5+IM-5
      DO 40 MI=IM,MUM
      NBQ=MA(MI)
      IF(NBQ.NE.NBP) GO TO 40
      LD(MUZ+I-1)=M
      GO TO 100
  40  CONTINUE
  45  CONTINUE
      IER=1
      WRITE(IOT,55) NBP,I
  55  FORMAT(/,10X,'BODY',I4,' IN UNIVERSE',I4,' IS NOT REFERENCED',
     1 ' POSITIVE IN THE UNIVERSE',//)
      GO TO 95
  50  CONTINUE
  95  CONTINUE
 100  CONTINUE
      WRITE(IOT,22) I,LD(II)
 200  CONTINUE
      IF(IER.EQ.0) GO TO 110
      CALL ERRTRA
CHANGED BY ST 96/12/18
C     CALL EXIT
      RETURN
 110  CONTINUE
      RETURN
      END
