      SUBROUTINE ZEXITS(D,MA,LOCREG,NUMBOD)
C * * THIS ROUTINE PRINTS THE COMBINATORIAL SUMMARY OF ZONE TRANSFERS
C     AT THE END OF A RUN.
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION MA(*),LOCREG(*),NUMBOD(*)
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
      COMMON/GOMLOC/ KMA,KFPD,KLCR,KNBD,KIOR,KRIZ,KRCZ,KMIZ,KMCZ,KKR1,
     1 KKR2,KNSR,KVOL,NADD,LDATA,LTMA,LFPD,NUMR,IRTRU,NUMB,NIR,KBIZ,KBCZ
C
      LC=57
      DO 800 I=1,NUMR
      N=LOCREG(I)+1
      NUM=NUMBOD(I)*5+N-5
      DO 800 J=N,NUM,5
      ICT=J+2
      IC=1
      GO TO 300
 100  CONTINUE
      I1=MA(ICT+2)
      IC=2
      GO TO 300
 120  CONTINUE
      ICT=I1
      IF(I1.GT.0) GO TO 100
      GO TO 800
 300  CONTINUE
      IV=1
      IF(LC.GE.54) IV=2
      GO TO (330,360),IV
 330  CONTINUE
      GO TO (370,380),IC
 360  CONTINUE
      WRITE(IOT,20)
      LC=8
 370  CONTINUE
      LC=LC+1
      WRITE(IOT,25) I,MA(J)
      IF(IC.EQ.1) GO TO 100
 380  CONTINUE
      LC=LC+1
      WRITE(IOT,30) ICT,MA(ICT),MA(ICT+1),I1
      GO TO 120
 800  CONTINUE
  20  FORMAT(1H1,//,34X,'COMBINATORIAL GEOMETRY ZONE TRANSFER SUMMARY',
     1' TABLES',//,32X,'EXIT',5X,'EXIT',5X,'LOC. IN',5X,'ENTERING',5X,
     2 'NO. OF',5X,'LOC. FOR',/,32X,'ZONE',5X,'BODY',5X,'MA ARRAY',6X,
     3 'ZONE',6X,'ENTRIES',5X,'NEXT ZONE',/)
  25  FORMAT(31X,I4,6X,I4)
  30  FORMAT(48X,I6,8X,I3,7X,I6,6X,I6)
      RETURN
      END
